Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3479)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3525)
@@ -775,5 +666,7 @@
 
 
-        CASE ( 'biom_pet_xy' )        ! 2d-array
+        CASE ( 'bio_pet*_xy' )        ! 2d-array
+            grid = 'zu1'
+            two_d = .TRUE.
             IF ( av == 0 )  THEN
               DO  i = nxl, nxr
@@ -798,6 +691,82 @@
 
 
- END SUBROUTINE biom_data_output_2d
-
+ END SUBROUTINE bio_data_output_2d
+
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining 3D output variables (dummy, always 2d!)
+!> data_output_3d 709ff
+!------------------------------------------------------------------------------!
+ SUBROUTINE bio_data_output_3d( av, variable, found, local_pf, nzb_do, nzt_do )
+
+    USE indices
+
+    USE kinds
+
+
+    IMPLICIT NONE
+
+!-- Input variables
+    CHARACTER (LEN=*), INTENT(IN) ::  variable   !< Char identifier to select var for output
+    INTEGER(iwp), INTENT(IN) ::  av       !< Use averaged data? 0 = no, 1 = yes?
+    INTEGER(iwp), INTENT(IN) ::  nzb_do   !< Unused. 2D. nz bottom to nz top
+    INTEGER(iwp), INTENT(IN) ::  nzt_do   !< Unused.
+
+!-- Output variables
+    LOGICAL, INTENT(OUT) ::  found   !< Output found?
+    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< Temp. result grid to return
+
+!-- Internal variables
+    INTEGER(iwp) ::  l    !< Running index, radiation grid
+    INTEGER(iwp) ::  i    !< Running index, x-dir
+    INTEGER(iwp) ::  j    !< Running index, y-dir
+    INTEGER(iwp) ::  k    !< Running index, z-dir
+
+    CHARACTER (LEN=:), allocatable ::  variable_short  !< Trimmed version of char variable
+
+    REAL(wp), PARAMETER ::  fill_value = -999._wp
+    REAL(wp) ::  mrt  !< Buffer for mean radiant temperature
+
+    found = .TRUE.
+    variable_short = TRIM( variable )
+
+    IF ( variable_short(1:4) /= 'bio_' ) THEN
+!--   Nothing to do, set found to FALSE and return immediatelly
+      found = .FALSE.
+      RETURN
+    ENDIF
+
+    SELECT CASE ( variable_short )
+
+        CASE ( 'bio_mrt' )
+            local_pf = REAL( fill_value, KIND = wp )
+            DO  l = 1, nmrtbl
+               i = mrtbl(ix,l)
+               j = mrtbl(iy,l)
+               k = mrtbl(iz,l)
+               IF ( k < nzb_do .OR. k > nzt_do .OR. j < nys .OR. j > nyn .OR.  &
+                  i < nxl .OR. i > nxr ) CYCLE
+               IF ( av == 0 )  THEN
+                  IF ( mrt_include_sw )  THEN
+                     local_pf(i,j,k) = ((human_absorb * mrtinsw(l) + human_emiss * mrtinlw(l)) /   &
+                                        (human_emiss * sigma_sb)) ** .25_wp - degc_to_k
+                  ELSE
+                     local_pf(i,j,k) = (human_emiss * mrtinlw(l) /             &
+                                        sigma_sb) ** .25_wp - degc_to_k
+                  ENDIF
+               ELSE
+                  local_pf(i,j,k) = mrt_av_grid(l)
+               ENDIF
+            ENDDO
+
+       CASE DEFAULT
+          found = .FALSE.
+
+    END SELECT
+
+ END SUBROUTINE bio_data_output_3d
 
 !------------------------------------------------------------------------------!
@@ -808,5 +777,5 @@
 !> netcdf_interface_mod 918ff
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
+ SUBROUTINE bio_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
 
     IMPLICIT NONE
@@ -836,6 +805,5 @@
     is2d = ( var(l-1:l) == 'xy' )
 
-
-    IF ( var(1:4) == 'biom' ) THEN
+    IF ( var(1:4) == 'bio_' ) THEN
        found  = .TRUE.
        grid_x = 'x'
@@ -845,5 +813,5 @@
     ENDIF
 
- END SUBROUTINE biom_define_netcdf_grid
+ END SUBROUTINE bio_define_netcdf_grid
 
 !------------------------------------------------------------------------------!
@@ -853,5 +821,5 @@
 !> header 982
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_header( io )
+ SUBROUTINE bio_header( io )
 
     IMPLICIT NONE
@@ -863,10 +831,10 @@
     CHARACTER (LEN=86) ::  output_height_chr  !< String for output height
 
-    WRITE( output_height_chr, '(F8.1,7X)' )  biom_output_height
+    WRITE( output_height_chr, '(F8.1,7X)' )  bio_output_height
 !
 !-- Write biom header
     WRITE( io, 1 )
     WRITE( io, 2 )  TRIM( output_height_chr )
-    WRITE( io, 3 )  TRIM( ACHAR( biom_cell_level ) )
+    WRITE( io, 3 )  TRIM( ACHAR( bio_cell_level ) )
 
 1   FORMAT (//' Human thermal comfort module information:'/                    &
@@ -875,5 +843,5 @@
 3   FORMAT ('    --> This corresponds to cell level : ', A )
 
- END SUBROUTINE biom_header
+ END SUBROUTINE bio_header
 
 
@@ -884,7 +852,7 @@
 !> init_3d_model 1987ff
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_init
-
-    USE control_parameters,                                                 &
+ SUBROUTINE bio_init
+
+    USE control_parameters,                                                    &
         ONLY: message_string
 
@@ -899,21 +867,20 @@
 !   (gravimetric center of sample human)
 
-    time_biom_results = 0.0_wp
-    biom_cell_level = 0_iwp
-    biom_output_height = 0.5_wp * dz(1)
+    time_bio_results = 0.0_wp
+    bio_cell_level = 0_iwp
+    bio_output_height = 0.5_wp * dz(1)
     height = 0.0_wp
 
-    biom_cell_level = INT ( 1.099_wp / dz(1) )
-    biom_output_height = biom_output_height + biom_cell_level * dz(1)
-
-    IF ( .NOT. radiation_interactions .AND. mrt_from_rtm ) THEN
-       message_string = 'The mrt_from_rtm switch require ' // &
+    bio_cell_level = INT ( 1.099_wp / dz(1) )
+    bio_output_height = bio_output_height + bio_cell_level * dz(1)
+
+    IF ( .NOT. radiation_interactions ) THEN
+       message_string = 'The mrt calculation requires ' // &
                         'enabled radiation_interactions but it ' // &
-                        'is disabled! Set mrt_from_rtm to .F.'
+                        'is disabled!'
        CALL message( 'check_parameters', 'PAHU03', 0, 0, -1, 6, 0 )
-       mrt_from_rtm = .FALSE.
-    ENDIF
-
- END SUBROUTINE biom_init
+    ENDIF
+
+ END SUBROUTINE bio_init
 
 
@@ -924,5 +891,5 @@
 !> init_3d_model 1047ff
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_init_arrays
+ SUBROUTINE bio_init_arrays
 
     IMPLICIT NONE
@@ -934,11 +901,11 @@
     ENDIF
 
-    IF ( biom_pt ) THEN
-      IF ( .NOT. ALLOCATED( pt_grid ) ) THEN
-        ALLOCATE( pt_grid (nys:nyn,nxl:nxr) )
+    IF ( bio_perct ) THEN
+      IF ( .NOT. ALLOCATED( perct ) ) THEN
+        ALLOCATE( perct (nys:nyn,nxl:nxr) )
       ENDIF
     ENDIF
 
-    IF ( biom_utci ) THEN
+    IF ( bio_utci ) THEN
       IF ( .NOT. ALLOCATED( utci_grid ) ) THEN
         ALLOCATE( utci_grid (nys:nyn,nxl:nxr) )
@@ -946,5 +913,5 @@
     ENDIF
 
-    IF ( biom_pet ) THEN
+    IF ( bio_pet ) THEN
       IF ( .NOT. ALLOCATED( pet_grid ) ) THEN
         ALLOCATE( pet_grid (nys:nyn,nxl:nxr) )
@@ -952,11 +919,11 @@
     END IF
 
-    IF ( biom_pt_av ) THEN
-      IF ( .NOT. ALLOCATED( pt_av_grid ) ) THEN
-        ALLOCATE( pt_av_grid (nys:nyn,nxl:nxr) )
+    IF ( bio_perct_av ) THEN
+      IF ( .NOT. ALLOCATED( perct_av ) ) THEN
+        ALLOCATE( perct_av (nys:nyn,nxl:nxr) )
       ENDIF
     ENDIF
 
-    IF ( biom_utci_av ) THEN
+    IF ( bio_utci_av ) THEN
       IF ( .NOT. ALLOCATED( utci_av_grid ) ) THEN
         ALLOCATE( utci_av_grid (nys:nyn,nxl:nxr) )
@@ -964,5 +931,5 @@
     ENDIF
 
-    IF ( biom_pet_av ) THEN
+    IF ( bio_pet_av ) THEN
       IF ( .NOT. ALLOCATED( pet_av_grid ) ) THEN
         ALLOCATE( pet_av_grid (nys:nyn,nxl:nxr) )
@@ -971,5 +938,5 @@
     END IF
 
- END SUBROUTINE biom_init_arrays
+ END SUBROUTINE bio_init_arrays
 
 
@@ -979,5 +946,5 @@
 !> Parin for &biometeorology_parameters for reading biomet parameters
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_parin
+ SUBROUTINE bio_parin
 
     IMPLICIT NONE
@@ -987,11 +954,10 @@
     CHARACTER (LEN=80) ::  line  !< Dummy string for current line in parameter file 
 
-    NAMELIST /biometeorology_parameters/  mrt_from_rtm,                        &
-                                          biom_pet,                            &
-                                          biom_pet_av,                         &
-                                          biom_pt,                             &
-                                          biom_pt_av,                          &
-                                          biom_utci,                           &
-                                          biom_utci_av
+    NAMELIST /biometeorology_parameters/  bio_pet,                             &
+                                          bio_pet_av,                          &
+                                          bio_perct,                           &
+                                          bio_perct_av,                        &
+                                          bio_utci,                            &
+                                          bio_utci_av
 
 
@@ -1025,187 +991,44 @@
 
 
- END SUBROUTINE biom_parin
+ END SUBROUTINE bio_parin
 
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculates the mean radiant temperature (tmrt) based on the Six-directions
-!> method according to VDI 3787 2.
-!------------------------------------------------------------------------------!
- SUBROUTINE calculate_tmrt_6_directions( SW_N, SW_E, SW_S, SW_W,               &
-    SW_U, SW_D, LW_N, LW_E, LW_S, LW_W, LW_U, LW_D, tmrt )
+!> Calculate biometeorology MRT for all 2D grid
+!------------------------------------------------------------------------------!
+ SUBROUTINE bio_calculate_mrt_grid ( av )
 
     IMPLICIT NONE
 
-!-- Type of input of the argument list
-!   Short- (SW_) and longwave (LW_) radiation fluxes from the six directions
-!   North (N), East (E), South (S), West (W), up (U) and down (D)
-    REAL(wp), INTENT ( IN )  ::  SW_N  !< Sw radflux density from N    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  SW_E  !< Sw radflux density from E    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  SW_S  !< Sw radflux density from S    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  SW_W  !< Sw radflux density from W    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  SW_U  !< Sw radflux density from U    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  SW_D  !< Sw radflux density from D    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  LW_N  !< Lw radflux density from N    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  LW_E  !< Lw radflux density from E    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  LW_S  !< Lw radflux density from S    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  LW_W  !< Lw radflux density from W    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  LW_U  !< Lw radflux density from U    (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  LW_D  !< Lw radflux density from D    (W/mÂ²)
-
-!-- Type of output of the argument list
-    REAL(wp), INTENT ( OUT ) ::  tmrt  !< Mean radiant temperature (Â°C)
-
-!-- Directional weighting factors
-    REAL(wp), PARAMETER      ::  weight_h  = 0.22_wp
-    REAL(wp), PARAMETER      ::  weight_v  = 0.06_wp
-
-    REAL(wp) ::  nrfd           !<  Net radiation flux density (W/mÂ²)
-
-!-- Initialise
-    nrfd = 0._wp
-
-!-- Compute mean radiation flux density absorbed by rotational symetric human
-    nrfd = ( weight_h * ( human_absorb * SW_N + human_emiss * LW_N ) ) +       &
-       ( weight_h * ( human_absorb * SW_E + human_emiss * LW_E ) ) +           &
-       ( weight_h * ( human_absorb * SW_S + human_emiss * LW_S ) ) +           &
-       ( weight_h * ( human_absorb * SW_W + human_emiss * LW_W ) ) +           &
-       ( weight_v * ( human_absorb * SW_U + human_emiss * LW_U ) ) +           &
-       ( weight_v * ( human_absorb * SW_D + human_emiss * LW_D ) )
-
-!-- Compute mean radiant temperature
-    tmrt = ( nrfd / (human_emiss * sigma_sb) )**0.25_wp - degc_to_k
-
- END SUBROUTINE calculate_tmrt_6_directions
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Very crude approximation of mean radiant temperature based on upwards and 
-!> downwards radiation fluxes only (other directions curently not available, 
-!> replace as soon as possible!)
-!------------------------------------------------------------------------------!
- SUBROUTINE calculate_tmrt_2_directions( sw_u, sw_d, lw_u, lw_d, ta, tmrt )
-
-    IMPLICIT NONE
-
-!-- Type of input of the argument list
-    REAL(wp), INTENT ( IN )  ::  sw_u  !< Shortwave radiation flux density from upper direction (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  sw_d  !< Shortwave radiation flux density from lower direction (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  lw_u  !< Longwave radiation flux density from upper direction (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  lw_d  !< Longwave radiation flux density from lower direction (W/mÂ²)
-    REAL(wp), INTENT ( IN )  ::  ta    !< Air temperature (Â°C)
-
-!-- Type of output of the argument list
-    REAL(wp), INTENT ( OUT ) ::  tmrt  !< mean radiant temperature, (Â°C)
-
-!-- Directional weighting factors and parameters
-    REAL(wp), PARAMETER ::  weight_h  = 0.22_wp     !< Weight for horizontal radiational gain after Fanger (1972)
-    REAL(wp), PARAMETER ::  weight_v  = 0.06_wp     !< Weight for vertical radiational gain after Fanger (1972)
-
-!-- Other internal variables
-    REAL(wp) ::  sw_in
-    REAL(wp) ::  sw_out
-    REAL(wp) ::  lw_in
-    REAL(wp) ::  lw_out
-    REAL(wp) ::  nrfd     !< Net radiation flux density (W/mÂ²)
-    REAL(wp) ::  lw_air   !< Longwave emission by surrounding air volume (W/mÂ²)
-    REAL(wp) ::  sw_side  !< Shortwave immission from the sides (W/mÂ²)
-
-    INTEGER(iwp) ::  no_input  !< Count missing input radiation fluxes
-
-!-- initialise
-    sw_in    = sw_u
-    sw_out   = sw_d
-    lw_in    = lw_u
-    lw_out   = lw_d
-    nrfd     = 0._wp
-    no_input = 0_iwp
-
-!-- test for missing input data
-    IF ( sw_in <= -998._wp .OR. sw_out <= -998._wp .OR. lw_in <= -998._wp .OR. &
-       lw_out <= -998._wp .OR. ta <= -998._wp ) THEN
-       IF ( sw_in <= -998._wp ) THEN
-          sw_in = 0.
-          no_input = no_input + 1
+    LOGICAL, INTENT(IN)         ::  av    !< use averaged input?
+!-- Internal variables
+    INTEGER(iwp)                ::  i     !< Running index, x-dir, radiation coordinates
+    INTEGER(iwp)                ::  j     !< Running index, y-dir, radiation coordinates
+    INTEGER(iwp)                ::  k     !< Running index, y-dir, radiation coordinates
+    INTEGER(iwp)                ::  l     !< Running index, radiation coordinates
+
+
+!-- Calculate biometeorology MRT from local radiation
+!-- fluxes calculated by RTM and assign into 2D grid
+    tmrt_grid = -999.
+    DO  l = 1, nmrtbl
+       i = mrtbl(ix,l)
+       j = mrtbl(iy,l)
+       k = mrtbl(iz,l)
+       IF ( k - get_topography_top_index_ji( j, i, 's' ) == bio_cell_level +   &
+             1_iwp) THEN
+          IF ( mrt_include_sw )  THEN
+              tmrt_grid(j,i) = ((human_absorb*mrtinsw(l) +                     &
+                                human_emiss*mrtinlw(l))  /                     &
+                               (human_emiss*sigma_sb)) ** .25_wp - degc_to_k
+          ELSE
+              tmrt_grid(j,i) = (human_emiss*mrtinlw(l) / sigma_sb) ** .25_wp   &
+                                 - degc_to_k
+          ENDIF
        ENDIF
-       IF ( sw_out <= -998._wp ) THEN
-          sw_out = 0.
-          no_input = no_input + 1
-       ENDIF
-       IF ( lw_in <= -998._wp ) THEN
-          lw_in = 0.
-          no_input = no_input + 1
-       ENDIF
-       IF ( lw_out <= -998._wp ) THEN
-          lw_out = 0.
-          no_input = no_input + 1
-       ENDIF
-
-!-- Accept two missing radiation flux directions, fail otherwise as error might become too large
-       IF ( ta <= -998._wp .OR. no_input >= 3 ) THEN
-          tmrt = -999._wp
-          RETURN
-       ENDIF
-    ENDIF
-
-    sw_side = sw_in * 0.125_wp  ! distribute half of upper sw_in to the 4 sides
-    lw_air = ( sigma_sb * 0.95_wp * ( ta + degc_to_k )**4 )
-
-!-- Compute mean radiation flux density absorbed by rotational symetric human
-    nrfd = ( weight_h * ( human_absorb * sw_side + human_emiss * lw_air ) ) +         &
-       ( weight_h * ( human_absorb * sw_side + human_emiss * lw_air ) ) +             &
-       ( weight_h * ( human_absorb * sw_side + human_emiss * lw_air ) ) +             &
-       ( weight_h * ( human_absorb * sw_side + human_emiss * lw_air ) ) +             &
-       ( weight_v * ( human_absorb * (sw_in * 0.5_wp) + human_emiss * lw_in ) ) +     &
-       ( weight_v * ( human_absorb * sw_out + human_emiss * lw_out ) )
-
-!-- Compute mean radiant temperature
-    tmrt = ( nrfd / (human_emiss * sigma_sb) )**0.25_wp - degc_to_k
-
- END SUBROUTINE calculate_tmrt_2_directions
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Calculate static thermal indices for given meteorological conditions
-!------------------------------------------------------------------------------!
- SUBROUTINE calculate_static_thermal_indices ( ta, vp, ws, pair, tmrt,         &
-    pt_static, utci_static, pet_static )
-
-    IMPLICIT NONE
-
-!-- Input parameters
-    REAL(wp), INTENT ( IN )  ::  ta           !< Air temperature                  (Â°C)
-    REAL(wp), INTENT ( IN )  ::  vp           !< Vapour pressure                  (hPa)
-    REAL(wp), INTENT ( IN )  ::  ws           !< Wind speed    (local level)      (m/s)
-    REAL(wp), INTENT ( IN )  ::  pair         !< Air pressure                     (hPa)
-    REAL(wp), INTENT ( IN )  ::  tmrt         !< Mean radiant temperature         (Â°C)
-!-- Output parameters
-    REAL(wp), INTENT ( OUT ) ::  pt_static    !< Perceived temperature            (Â°C)
-    REAL(wp), INTENT ( OUT ) ::  utci_static  !< Universal thermal climate index  (Â°C)
-    REAL(wp), INTENT ( OUT ) ::  pet_static   !< Physiologically equivalent temp. (Â°C)
-!-- Temporary field, not used here
-    REAL(wp)                 ::  clo          !< Clothing index (no dim.)
-
-    clo = -999._wp
-
-    IF ( biom_pt ) THEN
-!-- Estimate local perceived temperature
-       CALL calculate_pt_static( ta, vp, ws, tmrt, pair, clo, pt_static )
-    ENDIF
-
-    IF ( biom_utci ) THEN
-!-- Estimate local universal thermal climate index
-       CALL calculate_utci_static( ta, vp, ws, tmrt, biom_output_height,       &
-          utci_static )
-    ENDIF
-
-    IF ( biom_pet ) THEN
-!-- Estimate local physiologically equivalent temperature
-       CALL calculate_pet_static( ta, vp, ws, tmrt, pair, pet_static )
-    ENDIF
-
- END SUBROUTINE calculate_static_thermal_indices
+    ENDDO
+
+END SUBROUTINE bio_calculate_mrt_grid
 
 
@@ -1215,6 +1038,6 @@
 !> Calculate static thermal indices for 2D grid point i, j
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_determine_input_at( average_input, i, j, ta, vp, ws, pair,    &
-    tmrt )
+ SUBROUTINE bio_get_thermal_index_input_ij( average_input, i, j, ta, vp, ws,   &
+    pair, tmrt )
 
     IMPLICIT NONE
@@ -1234,5 +1057,9 @@
 !-- Internal variables
     INTEGER(iwp)                ::  k     !< Running index, z-dir
+    INTEGER(iwp)                ::  ir    !< Running index, x-dir, radiation coordinates
+    INTEGER(iwp)                ::  jr    !< Running index, y-dir, radiation coordinates
+    INTEGER(iwp)                ::  kr    !< Running index, y-dir, radiation coordinates
     INTEGER(iwp)                ::  k_wind  !< Running index, z-dir, wind speed only
+    INTEGER(iwp)                ::  l     !< Running index, radiation coordinates
 
     REAL(wp)                    ::  vp_sat  !< Saturation vapor pressure     (hPa)
@@ -1241,8 +1068,11 @@
 !-- Determine cell level closest to 1.1m above ground
 !   by making use of truncation due to int cast
-    k = get_topography_top_index_ji(j, i, 's') + biom_cell_level  !< Vertical cell center closest to 1.1m
+    k = get_topography_top_index_ji(j, i, 's') + bio_cell_level  !< Vertical cell center closest to 1.1m
+
+!
+!-- Avoid non-representative horizontal u and v of 0.0 m/s too close to ground
     k_wind = k
-    IF( k_wind < 1_iwp ) THEN  ! Avoid horizontal u and v of 0.0 m/s close to ground
-       k_wind = 1_iwp
+    IF ( bio_cell_level < 1_iwp ) THEN
+       k_wind = k + 1_iwp
     ENDIF
 
@@ -1252,5 +1082,5 @@
        ta = pt_av(k, j, i) - ( 0.0098_wp * dz(1) * (  k + .5_wp ) ) - degc_to_k
 
-       vp = 0.034_wp
+       vp = -999._wp
        IF ( humidity .AND. ALLOCATED( q_av ) ) THEN
           vp = q_av(k, j, i)
@@ -1264,5 +1094,8 @@
        ta = pt(k, j, i) - ( 0.0098_wp * dz(1) * (  k + .5_wp ) ) - degc_to_k
 
-       vp = q(k, j, i)
+       vp = -999._wp
+       IF ( humidity ) THEN
+          vp = q(k, j, i)
+       ENDIF
 
        ws = ( 0.5_wp * ABS( u(k_wind, j, i) + u(k_wind, j, i+1) )  +           &
@@ -1278,20 +1111,18 @@
 !-- The magnus formula is limited to temperatures up to 333.15 K to
 !   avoid negative values of vp_sat
-    vp_sat = 0.01_wp * magnus( MIN( ta + degc_to_k, 333.15_wp ) )
-    vp  = vp * pair / ( vp + 0.622_wp )
-    IF ( vp > vp_sat ) vp = vp_sat
-
-    tmrt = ta
+    IF ( vp > -998._wp ) THEN
+       vp_sat = 0.01_wp * magnus( MIN( ta + degc_to_k, 333.15_wp ) )
+       vp  = vp * pair / ( vp + 0.622_wp )
+       IF ( vp > vp_sat ) vp = vp_sat
+    ENDIF
+
+!-- local mtr value at [i,j]
+    tmrt = -999.  !< this can be a valid result (e.g. for inside some ostacle)
     IF ( radiation ) THEN
-       IF ( mrt_from_rtm ) THEN
-          tmrt = tmrt_grid(j, i)
-       ELSE
-          CALL calculate_tmrt_2_directions (rad_sw_in(0, j, i),                &
-             rad_sw_out(0, j, i), rad_lw_in(0, j, i), rad_lw_out(0, j, i), ta, &
-             tmrt )
-       ENDIF
-    ENDIF
-
- END SUBROUTINE biom_determine_input_at
+!--    Use MRT from RTM precalculated in tmrt_grid
+       tmrt = tmrt_grid(j,i)
+    ENDIF
+
+ END SUBROUTINE bio_get_thermal_index_input_ij
 
 
@@ -1302,83 +1133,85 @@
 !> time_integration.f90: 1065ff
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_calculate_static_grid ( average_input )
+ SUBROUTINE bio_calculate_thermal_index_maps ( av )
 
     IMPLICIT NONE
 
 !-- Input attributes
-    LOGICAL, INTENT ( IN ) ::  average_input  !< Calculate based on averaged input? conditions?
+    LOGICAL, INTENT ( IN ) ::  av  !< Calculate based on averaged input conditions?
 
 !-- Internal variables
-    INTEGER(iwp) ::  i, j, k, l   !< Running index
-
+    INTEGER(iwp) ::  i, j      !< Running index
+
+    REAL(wp) ::  clo           !< Clothing index                (no dimension)
     REAL(wp) ::  ta            !< Air temperature                  (Â°C)
     REAL(wp) ::  vp            !< Vapour pressure                  (hPa)
     REAL(wp) ::  ws            !< Wind speed    (local level)      (m/s)
     REAL(wp) ::  pair          !< Air pressure                     (hPa)
-    REAL(wp) ::  tmrt_tmp      !< Mean radiant temperature
-    REAL(wp) ::  pt_tmp        !< Perceived temperature
-    REAL(wp) ::  utci_tmp      !< Universal thermal climate index
-    REAL(wp) ::  pet_tmp       !< Physiologically equivalent temperature
-
-
-    CALL biom_init_arrays
-
-    IF ( mrt_from_rtm ) THEN
-       tmrt_grid = -999._wp
-       DO  l = 1, nmrtbl
-           i = mrtbl(ix,l)
-           j = mrtbl(iy,l)
-           k = mrtbl(iz,l)
-           IF ( k - get_topography_top_index_ji( j, i, 's' ) == 1  ) THEN
-              IF ( mrt_include_sw )  THEN
-                  tmrt_tmp = ((human_absorb*mrtinsw(l) + human_emiss*mrtinlw(l)) &
-                             / (human_emiss*sigma_sb)) ** .25_wp
-              ELSE
-                  tmrt_tmp = (human_emiss*mrtinlw(l) / sigma_sb) ** .25_wp
-              ENDIF
-              tmrt_grid(j, i) = tmrt_tmp - degc_to_k
-           ENDIF
-       ENDDO
-    ENDIF
+    REAL(wp) ::  perct_tmp     !< Perceived temperature            (Â°C)
+    REAL(wp) ::  utci_tmp      !< Universal thermal climate index  (Â°C)
+    REAL(wp) ::  pet_tmp       !< Physiologically equivalent temperature  (Â°C)
+    REAL(wp) ::  tmrt_tmp      !< Mean radiant temperature         (Â°C)
+
+    CALL bio_init_arrays
+
+!-- fill out the MRT 2D grid from appropriate source (RTM, RRTMG,...)
+    CALL bio_calculate_mrt_grid ( av )
+
 
     DO i = nxl, nxr
        DO j = nys, nyn
 !--       Determine local input conditions
-          CALL biom_determine_input_at ( average_input, i, j, ta, vp, ws,      &
-               pair, tmrt_tmp )
-          tmrt_grid(j, i) = tmrt_tmp
-
-!--       Only proceed if tmrt is available
-          IF ( tmrt_tmp <= -998._wp ) THEN
-             pt_tmp   = -999._wp
+          CALL bio_get_thermal_index_input_ij ( av, i, j, ta, vp,              &
+               ws, pair, tmrt_tmp )
+!           tmrt_grid(j, i) = tmrt_tmp  !< already set by bio_calculate_mrt_grid!
+
+!--       Only proceed if input is available
+          IF ( tmrt_tmp <= -998._wp .OR. vp <= -998._wp ) THEN
+             pet_tmp = -999._wp         !< set fail value, e.g. valid for within
+             perct_tmp  = -999._wp      !< some obstacle
              utci_tmp = -999._wp
-             pet_tmp  = -999._wp
-             CYCLE
+          ELSE
+!--          Calculate static thermal indices based on local tmrt
+             clo = -999._wp
+             
+             IF ( bio_perct ) THEN
+!--          Estimate local perceived temperature
+                CALL calculate_perct_static( ta, vp, ws, tmrt_tmp, pair, clo,  &
+                   perct_tmp )
+             ENDIF
+             
+             IF ( bio_utci ) THEN
+!--          Estimate local universal thermal climate index
+                CALL calculate_utci_static( ta, vp, ws, tmrt_tmp,              &
+                   bio_output_height, utci_tmp )
+             ENDIF
+             
+             IF ( bio_pet ) THEN
+!--          Estimate local physiologically equivalent temperature
+                CALL calculate_pet_static( ta, vp, ws, tmrt_tmp, pair, pet_tmp )
+             ENDIF
           END IF
 
-!--       Calculate static thermal indices based on local tmrt
-          CALL calculate_static_thermal_indices ( ta, vp, ws,                  &
-             pair, tmrt_tmp, pt_tmp, utci_tmp, pet_tmp )
-
-          IF ( average_input ) THEN
+
+          IF ( av ) THEN
 !--          Write results for selected averaged indices
-             IF ( biom_pt_av )  THEN
-                pt_av_grid(j, i)   = pt_tmp
+             IF ( bio_perct_av )  THEN
+                perct_av(j, i) = perct_tmp
              END IF
-             IF ( biom_utci_av ) THEN
+             IF ( bio_utci_av ) THEN
                 utci_av_grid(j, i) = utci_tmp
              END IF
-             IF ( biom_pet_av ) THEN
+             IF ( bio_pet_av ) THEN
                 pet_av_grid(j, i)  = pet_tmp
              END IF
           ELSE
 !--          Write result for selected indices
-             IF ( biom_pt )  THEN
-                pt_grid(j, i)   = pt_tmp
+             IF ( bio_perct )  THEN
+                perct(j, i) = perct_tmp
              END IF
-             IF ( biom_utci ) THEN
+             IF ( bio_utci ) THEN
                 utci_grid(j, i) = utci_tmp
              END IF
-             IF ( biom_pet ) THEN
+             IF ( bio_pet ) THEN
                 pet_grid(j, i)  = pet_tmp
              END IF
@@ -1388,5 +1221,5 @@
     END DO
 
- END SUBROUTINE biom_calculate_static_grid
+ END SUBROUTINE bio_calculate_thermal_index_maps
 
 !------------------------------------------------------------------------------!
@@ -1395,5 +1228,5 @@
 !> Calculate dynamic thermal indices (currently only iPT, but expandable)
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_calc_ipt( ta, vp, ws, pair, tmrt, dt, energy_storage,         &
+ SUBROUTINE bio_calc_ipt( ta, vp, ws, pair, tmrt, dt, energy_storage,          &
     t_clo, clo, actlev, age, weight, height, work, sex, ipt )
 
